#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<unistd.h>
#include <math.h>
#include <pthread.h>
#include <semaphore.h>

#include "rssi_list.h"
#include "pcap-thread.h"

Element * rssi_list;
sem_t synchro;

void connection_handler(void *);

int main(int argc , char *argv[]){
    int socket_desc , new_socket , c , *new_sock;
    struct sockaddr_in server , client;
    char *message;
    char *device = argv[1];
    pthread_t pcap;
    rssi_list = malloc(sizeof(Element));
    //Create socket
    socket_desc = socket(AF_INET , SOCK_STREAM , 0);
    if (socket_desc == -1){
        printf("Could not create socket");
    }

    if(argc != 2){
        printf("Wrong number of arguments !!!\n");
        return 0;
    }
    //Prepare the sockaddr_in structure
    server.sin_family = AF_INET;
    server.sin_addr.s_addr = INADDR_ANY;
    server.sin_port = htons( 8888 );

    //Bind
    if( bind(socket_desc,(struct sockaddr *)&server , sizeof(server)) < 0){
        printf("bind failed\n");
        return 1;
    }
    printf("bind done\n");

    //Listen
    listen(socket_desc , 3);
    //Accept and incoming connection
    printf("Waiting for the server\n");
    c = sizeof(struct sockaddr_in);
    sem_init( &synchro, 0, 1 );
    pthread_create(&pcap, NULL, *pcap_function, device);
    printf("pcap function launched\n");
    while( (new_socket = accept(socket_desc, (struct sockaddr *)&client, (socklen_t*)&c)) ){
        printf("Server is connected\n");
        new_sock = malloc(1);
        *new_sock = new_socket;
        connection_handler( (void*) new_sock);
        printf("Handler assigned\n");
    }

    if (new_socket<0){
        perror("accept failed");
        return 1;
    }

    return 0;
}

void connection_handler(void *socket_desc){
    int sock = *(int*)socket_desc;
    int read_size, i, same, found = 0;
    char *message ;
    unsigned char client_mac[6];
    int default_nan= 4000;
    Element * k = rssi_list;
    printf("sizeof %d\n", sizeof(int));
    //Receive a message from client
    while( (read_size = recv(sock, client_mac, 6, 0)) > 0 ){
        //printf("%s\n", client_mac);
        printf("Asking MAC - %d:%d:%d:%d:%d:%d \n",
        client_mac[0], client_mac[1], client_mac[2], client_mac[3], client_mac[4], client_mac[5]);

        sem_wait(&synchro);
        while(k != NULL){
            same = 0;
            printf("MAC : ");
            for(i = 0;i < 6; ++i){
                    //printf("%2x:", k->mac_addr[i]);
                    //printf("%2x:", client_mac[i]);
                if(k->mac_addr[i] == client_mac[i]){
                    same ++;
                }else{
                    same = 0;
                }
                printf("%2x:", k->mac_addr[i]);
                if(same == 0)
                    break;
            }
            printf(" same = %d \n", same);
            if(same == 6){
                send(sock, &k->measurements.tail->rssi_mW, sizeof(int), 0);
                printf("resultat %x\n", &k->measurements.tail->rssi_mW);
                found = 1;
                break;
            }
            k = k->next;
        }
        sem_post(&synchro);
        if(!found){
            printf("Not found %x\n", default_nan);
            send(sock, &default_nan, sizeof(int), 0);
        }
        memset(client_mac, 0, 6);
    }

    if(read_size == 0){
        printf("Server disconnected\n");
        //fflush(stdout);
    }
    else if(read_size == -1){
        perror("recv failed");
    }

    //Free the socket pointer
    free(socket_desc);
}
