package android.application.lo53.initialization;

import android.content.Intent;
import android.os.Bundle;
import android.os.StrictMode;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

/**
 * The activity that manage the access point adding interface
 */
public class AccessPoint extends AppCompatActivity implements View.OnClickListener{
    /**
    *declare components
     */
    Button btnsend_ap;
    Button btn_back;

    EditText txt_name;
    EditText txt_ip;

    /*
    *a connection to server instance
    */
    Connexion cnx;

    String msg_afficher="";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_access_point);
        int SDK_INT = android.os.Build.VERSION.SDK_INT;
        if (SDK_INT > 8) {
            StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);

        }
        txt_ip= (EditText) findViewById(R.id.txt_ip);
        txt_name= (EditText) findViewById(R.id.txt_name);
        cnx = new Connexion();
        //msg_afficher=cnx.init();
        /*if (msg_afficher.contains("200"))
            msg_afficher = "Initializing ...";
        else {
            msg_afficher = "Unable to initialize try later";
            Toast.makeText(getBaseContext(),msg_afficher , Toast.LENGTH_LONG).show();
            startActivity(new Intent(this, Homepage.class));
        }*/
        Toast.makeText(getBaseContext(),msg_afficher , Toast.LENGTH_LONG).show();
        btn_back = (Button) findViewById(R.id.btnback_A);
        btnsend_ap = (Button) findViewById(R.id.btnsend_ap);
        btnsend_ap.setOnClickListener(this);
        btn_back.setOnClickListener(this);

    }
    /**
    *Manage the click action
     */
    @Override
    public void onClick(View v){
        switch (v.getId()) {

            case R.id.btnback_A:
                /**
                 *get the database ready & initialized it
                 *read the written x and y
                 *send it to server in order to save it
                 *request the user to move
                 */
                startActivity(new Intent(this, Homepage.class));
                break;
            case R.id.btnsend_ap :
                if(txt_ip.getText().toString().length()==0|| txt_name.getText().toString().length()==0 ){
                    Toast.makeText(getBaseContext(), "Enter data requestested please", Toast.LENGTH_LONG).show();
                }

                else{
                    try {
                        msg_afficher = cnx.send_ap(Integer.parseInt(txt_ip.getText().toString()),txt_name.getText().toString());
                        if(msg_afficher.contains("200")){
                            msg_afficher = "access point saved";
                        }else {
                            msg_afficher = "Unable to save please try again";
                        }
                        //ProgressDialog.show(this,"", "Chargement", true);
                        txt_ip.setText("");
                        txt_name.setText("");
                        Toast.makeText(getBaseContext(),msg_afficher , Toast.LENGTH_LONG).show();
                    }catch (NumberFormatException  e){
                        Toast.makeText(getBaseContext(),"Enter the correct type of values please" , Toast.LENGTH_LONG).show();
                    }
                }
                break;
        }
    }
}
