package lo53.application.android.localisation;


import android.content.Context;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

/*
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
*/

/**
 *<b>Connexion class to manage the device / server connexion</b>
 * <p>Attributes :
 *  <ul>
 *      <li>User Agent we choose Mozilla version 5.0</li>
 *      <li>the ip of the server</li>
 *      <li>the string to compose the url</li>
 *      <li>an url connection to establish conection to a given url</li>
 *      <li>an url attribute composed by the string url given  </li>
 *      <li>an Http connection to establish a connection in http mode </li>
 *      <li>resCode an integer to know if the connection went well</li>
 *      <li>response a buffer were we stock the data sent by the server</li>
 *   </ul>
 *</p>
 * @since 2016
 */
public class Connexion {
    private final String USER_AGENT = "Mozilla/5.0";
    private String ip;
    private String urlStr;
    private URLConnection urlConn;
    private URL url;
    private HttpURLConnection httpConn;
    private int resCode = -1;
    private StringBuffer response;
    String mac;
   // private DefaultHttpClient httpClient;
   // private HttpResponse httpResponse;
    private InputStream inputStream;
    /**
    *Constructeur
     */
    public Connexion(){
        ip="192.168.1.202";
        urlStr = "http://"+ip+":5001/";
        mac="";
        //httpClient = new DefaultHttpClient();
    }

    /**
     * générate flux
     * @return
     */
    public  int génére(){
        try {
            URL u = new URL("http://www.google.com");

            URLConnection urlConnection = url.openConnection();
            HttpURLConnection httpUrlConnection = (HttpURLConnection)urlConnection;
            if (httpUrlConnection.getResponseCode() == HttpURLConnection.HTTP_OK)
                return httpUrlConnection.getResponseCode();
        }
        catch (Exception e){
            e.getStackTrace();
        }
        return 0;
    }
    /**
    *Create url in order to send data to the
    *givin adress towards the server
     */
    private void create_url(String link){

        urlStr = "http://"+ip+":5001/"+link;
    }
    /**
    *establish connexion towards the server
    *@param met : POSt or GET
    *@return msg : Connexion succeded or not
     */
    private String establish_cnx(String met){
        try {

            url = new URL(urlStr);
            urlConn = url.openConnection();

            urlConn.setRequestProperty("User-Agent", USER_AGENT);
            if (!(urlConn instanceof HttpURLConnection)) {
                //throw new IOException("URL isn't an http url");
                return "URL isn't an http url";
            }
            //http connection
            httpConn = (HttpURLConnection) urlConn;
            httpConn.setAllowUserInteraction(false);
            httpConn.setInstanceFollowRedirects(true);
           // httpConn.setReadTimeout(1000 /* milliseconds */);
           // httpConn.setConnectTimeout(1000 /* milliseconds */);
            httpConn.setDoInput(true);
            httpConn.setRequestMethod(met);
            httpConn.connect();
            //code pour assurer cnx : 200 ok, 404 ou autre nop
            resCode = httpConn.getResponseCode();
            //

            if (resCode == HttpURLConnection.HTTP_OK) {
                //lecture

                BufferedReader in = new BufferedReader(new InputStreamReader(httpConn.getInputStream()));
                String inputLine;
                response = new StringBuffer();

                while ((inputLine = in.readLine()) != null) {
                    response.append(inputLine);
                }
                return response+":200";
            }

        } catch (MalformedURLException e) {
            e.printStackTrace();
            return  "Mal formed URL";
        } catch (IOException e) {
            e.printStackTrace();
            return  "input unknown"+e.getMessage();
        }
        return "System crached please try again later";
    }
    /**
    *Send data to the server
    *@param data : mac adresse or coordination or request coordination
    *@return success in sending data or not
     */
    private String send_data(String data){
        String msg="";
        try {

            url = new URL(urlStr);
            urlConn = url.openConnection();

            urlConn.setRequestProperty("User-Agent", USER_AGENT);
            if (!(urlConn instanceof HttpURLConnection)) {
                return "URL isn't an http url";
            }
            //http connection
            httpConn = (HttpURLConnection) urlConn;
            httpConn.setAllowUserInteraction(false);
            httpConn.setInstanceFollowRedirects(true);
            httpConn.setRequestMethod("POST");
            httpConn.connect();
            DataOutputStream wr = new DataOutputStream(httpConn.getOutputStream());
            wr.writeBytes(data);
            wr.flush();
            wr.close();
            //code to assure cnx : 200 = ok

            resCode = httpConn.getResponseCode();

            msg=resCode+"";
            if (resCode == HttpURLConnection.HTTP_OK) {
                //read what's sent from the server

                BufferedReader in = new BufferedReader(new InputStreamReader(httpConn.getInputStream()));
                String inputLine;
                response = new StringBuffer();

                while ((inputLine = in.readLine()) != null) {
                    response.append(inputLine);
                }
                return response+": 200";
            }

        } catch (MalformedURLException e) {
            e.printStackTrace();
            return  "Mal formed URL";
        } catch (IOException e) {
            e.printStackTrace();
            return  "input unknown"+e.getCause();
        }
        return "System crached please try again later";
    }
    /**
    *Request database initialization
    *in order to send the mac adress after it
     */
    public String init(){
        create_url("init_loc");
        return establish_cnx("GET");
    }
    /**
    *get the mac adress from the device
    *SEnd it to the server
     */
    public String send_mac(Context cntx) {

        WifiManager manager = (WifiManager) cntx.getSystemService(Context.WIFI_SERVICE);
        String macAddress = manager.getConnectionInfo().getMacAddress();
        mac = macAddress;

        //create_url("send_mac_loc");
        return "";//send_data("mac=" + mac);
    }
    /**
    *Send the request for the location
    *and get the location
    *stock it in a variable
    *and convert the giving location to the image scale
     */
    public String get_loc() {

        create_url("get_loc?mac="+mac);
        String msg = establish_cnx("GET");
        if(msg.contains("200")) {
            //stock the location in a global static variable
            Plan.loc.setX(Float.parseFloat(msg.split(":")[1].split(",")[0]));
            Plan.loc.setY(Float.parseFloat(msg.split(":")[1].split(",")[1].split(":")[1]));
            Plan.loc.convert();
            return msg;
        }

        return msg;
    }
    /**
    *(RE)Connection to a wifi with a giving SSID
    *in order to have flux to update the location
     */
    /**
     *Establish the reconnexion  to the current wifi SSID
     *@param cntx
     * The application context
     *@param state_wifi
     *Wifi status connected(true) disconnected(false)

     */
    public boolean selectSSID(Context cntx, boolean state_wifi){
        try {
            WifiManager wifiManager = (WifiManager) cntx.getSystemService(cntx.WIFI_SERVICE);
            WifiInfo wifiInfo = wifiManager.getConnectionInfo();
            String ssid = wifiInfo.getSSID();
            wifiManager.setWifiEnabled(state_wifi);

            WifiConfiguration conf = new WifiConfiguration();
            conf.SSID = "\"" + ssid + "\"";
            conf.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);
            conf.priority = 0xBADBAD;
            conf.status = WifiConfiguration.Status.ENABLED;
            conf.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);

            int id = wifiManager.addNetwork(conf);

            wifiManager.disconnect();
            wifiManager.enableNetwork(id, true);
            while (!wifiManager.reconnect());
            return true;
        }catch (Exception e){
            return false;
        }

    }
}


