## Setup sequence diagram
```
  Server             Device                  AP1                AP2            AP3
    |    MAC+loc(x,y)  |                      |                  |              |
    |<-----------------|                      |                  |              |
    |  OK, computing   |                      |                  |              |
    |----------------->|                      |                  |              |
    |                  |Find Device's info    |                  |              |
    |------------------+--------------------->+----------------->+------------->|
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------|                  |              |
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------+------------------|              |
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------+------------------+---------------
    |                  |                      |                  |              |
 Compute RSSI Sample   |                      |                  |              |
 then Fingerprint      |                      |                  |              |
 then map to location  |                      |                  |              |
 then save             |                      |                  |              |
    |                  |                      |                  |              |
    |   OK, saved      |                      |                  |              |
    |----------------->|                      |                  |              |
    |                  |                      |                  |              |
```

## Localisation sequence diagram
```
  Server             Device                  AP1                AP2            AP3
    |     find me      |                      |                  |              |
    |<-----------------|                      |                  |              |
    |       OK         |                      |                  |              |
    |----------------->|                      |                  |              |
    |Give me your MAC  |                      |                  |              |
    |----------------->|                      |                  |              |
    |    MAC address   |                      |                  |              |
    |<-----------------|                      |                  |              |
    |                  |Find Device's info    |                  |              |
    |------------------+--------------------->+----------------->+------------->|
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------|                  |              |
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------+------------------|              |
    |                  |   Infos              |                  |              |
    |<-----------------+----------------------+------------------+---------------
    |                  |                      |                  |              |
 Compute               |                      |                  |              |
 location              |                      |                  |              |
    |                  |                      |                  |              |
    |    location      |                      |                  |              |
    |----------------->|                      |                  |              |
    |                  |                      |                  |              |
```


## Database model

```
----------------    ----------------   ----------------
|   Location   |    | Fingerprint  |   | Access point |
----------------    ----------------   ----------------
| - id         |----| - id         |---| - id         |
| - x          |    | - loc_id     |   | - mac        |
| - y          |    | - dev_id     |   ----------------
| (- z)        |    | - ap_id      |
----------------    ----------------
                           |
                           |
                    ----------------
                    |    Device    |
                    ----------------
                    | - id         |
                    | - name       |
                    | - mac        |
                    ----------------
```


## Softwares

Three software:
  - One in C for the access points
  - One in Java/Android for the device
  - One in Python for the server

*HTTP1* protocol for every communications

